﻿Option Strict On

Public Class Form1
    Private Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Integer) As Integer
    'Declare Function waveOutSetVolume Lib "MMSYSTEM.DLL" (ByVal wDeviceID As Integer, ByVal dwVolume As Long) As Integer
    Declare Function waveOutSetVolume Lib "winmm.dll" (ByVal wDeviceID As Integer, ByVal dwVolume As Long) As Integer
    'Declare Function waveOutGetVolume Lib "MMSYSTEM.DLL" (ByVal wDeviceID As Integer, dwVolume As Long) As Integer


    Private Const sndAsync As Integer = &H1
    Private Const sndSync As Integer = &H0
    Private Const sndNoDefault As Integer = &H2
    Private Const sndLoop As Integer = &H8
    Private Const sndNoStop As Integer = &H10

    Dim Flags As Integer = sndSync Or sndNoDefault

    Dim trd As Threading.Thread
    Dim wavFilePath As String

    Dim ModeStop As Boolean = False
    Dim ModeTimer As Boolean = False
    Dim ModeTimerValue As Integer = 2000
    Dim ModeAsync As Boolean = False
    Dim ModeLoop As Boolean = False
    Dim TimesToLoop As Integer = -1
    Dim StopSame As Boolean = False
    Dim StartUnique As Boolean = False

    Dim UsingVolumeAtAll As Boolean = False

    Dim DesiredVolume As Long = 100
    Dim ActualVolume As Long = &HFFFFFFFF

    Dim DesiredVolumeLeft As Long = 100
    Dim ActualVolumeLeft As Long = &HFFFF
    Dim UsingVolumeLeft As Boolean = False

    Dim DesiredVolumeRight As Long = 100
    Dim ActualVolumeRight As Long = &HFFFF
    Dim UsingVolumeRight As Boolean = False

    Dim UsingVolumeHex As Boolean = False
    Dim DesiredVolumeHex As Long = &HFFFFFFFF


    Dim IndividualStopfile As String = "stopfile" '
    Dim IndividualStartfile As String = "startfile"

    ' PlayWav is launched as a thread so it doesn't block the gui
    Private Sub PlayWav()
        Dim i As Integer = 0
        If (UsingVolumeAtAll) Then
            waveOutSetVolume(0, ActualVolume)
        End If

        If ModeLoop = True Then
            While i < TimesToLoop Or TimesToLoop = -1

                sndPlaySound(System.IO.Path.GetFullPath(wavFilePath), Flags)
                i += 1
            End While

        Else
            sndPlaySound(System.IO.Path.GetFullPath(wavFilePath), Flags)
        End If

        ' ending naturally, drop the startfile
        If Dir(IndividualStartfile) <> "" Then
            Kill(IndividualStartfile)
        End If

        ' being as we are ending naturally, we should be nice and clean up the other junk
        If Dir("stopfile") <> "" Then
            Kill("stopfile")
        End If

        If Dir(IndividualStopfile) <> "" Then
            Kill(IndividualStopfile)
        End If

        ' ending naturally, drop the startfile
        If Dir(IndividualStartfile) <> "" Then
            Kill(IndividualStartfile)
        End If

        TerminateSelf()


    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' @@ pretty sure some of these don't help.  But basically we want the window to be completely missing.
        ' it also starts minimized
        Me.Opacity = 0
        Me.Visible = False
        Me.Hide()

        tmrCheckStopFile.Enabled = True
        tmrJustStarted.Enabled = True

        Dim args() As String = System.Environment.GetCommandLineArgs()

        ' set the window name, I *think* this shows up on the task manager in win7.
        Me.Text = String.Join(" ", args)


        For i As Integer = 0 To UBound(args)
            'this will eventually be set to the last value, unless the last value matched an option, in which case ""
            wavFilePath = args(i)

            If args(i) = "--id" Or args(i) = "/id" Then
                IndividualStopfile = args(i + 1) + ".stopfile"
                IndividualStartfile = args(i + 1) + ".startfile"
                wavFilePath = ""
            End If

            If args(i) = "--stopbyid" Or args(i) = "/stopbyid" Then
                StopSame = True
                wavFilePath = ""
            End If

            If args(i) = "--unique" Or args(i) = "/unique" Then
                StartUnique = True
                wavFilePath = ""
            End If

            If args(i) = "-s" Or args(i) = "/s" Or args(i) = "/S" Or args(i) = "/stop" Or args(i) = "--stop" Then
                ModeStop = True
                wavFilePath = ""
            End If

            If args(i) = "/vol" Or args(i) = "/volume" Or args(i) = "--volume" Then
                UsingVolumeAtAll = True
                DesiredVolume = Convert.ToInt32(args(i + 1))
            End If

            If args(i) = "/right" Or args(i) = "--right" Then
                UsingVolumeAtAll = True
                DesiredVolumeRight = Convert.ToInt32(args(i + 1))
                UsingVolumeRight = True
            End If

            If args(i) = "/left" Or args(i) = "--left" Then
                UsingVolumeAtAll = True
                DesiredVolumeLeft = Convert.ToInt32(args(i + 1))
                UsingVolumeLeft = True
            End If

            If args(i) = "/volhex" Or args(i) = "--volhex" Then
                UsingVolumeAtAll = True
                DesiredVolumeHex = Convert.ToInt64(args(i + 1), 16)
                UsingVolumeHex = True
            End If

            ' timer mode.  We will cut the sound off after X ms
            If args(i) = "-t" Or args(i) = "/t" Or args(i) = "/T" Or args(i) = "/timer" Or args(i) = "--timer" Then
                ModeTimer = True

                Try
                    ModeTimerValue = Convert.ToInt32(args(i + 1))
                Catch ex As FormatException
                    ModeTimerValue = 2000
                Catch ex As OverflowException
                    ModeTimerValue = 2000
                Catch ex As Exception
                    ModeTimerValue = 2000
                End Try

                wavFilePath = ""
            End If

            ' asynchronous mode.  We will return control immediately, but the window playing the sound will
            ' hang out until ModeTimerValue seconds has passed
            ' @@ doesn't really do anything because we are kicking off a secret window anyway
            If args(i) = "-a" Or args(i) = "/a" Or args(i) = "/A" Or args(i) = "/async" Or args(i) = "--async" Then
                ModeAsync = True
                Flags = Flags Or sndAsync
                wavFilePath = ""
            End If

            If args(i) = "-l" Or args(i) = "/l" Or args(i) = "/L" Or args(i) = "/loop" Or args(i) = "--loop" Then
                ModeLoop = True

                Try
                    TimesToLoop = Convert.ToInt32(args(i + 1))
                Catch ex As FormatException
                    TimesToLoop = -1
                Catch ex As OverflowException
                    TimesToLoop = -1
                Catch ex As Exception
                    TimesToLoop = -1
                End Try

                '@@ flag for sndLoop didn't seem to work anyway, doing a real while loop instead
                'Flags = Flags Or sndLoop
                wavFilePath = ""
            End If

            If UBound(args) = 0 Or args(i) = "-h" Or args(i) = "/H" Or args(i) = "/h" Or args(i) = "/?" Or args(i) = "/help" _
                Or args(i) = "-v" Or args(i) = "/v" Or args(i) = "/V" Or args(i) = "/version" Or args(i) = "--version" Then
                Me.Show()
                Me.Opacity = 1
                Me.Visible = True
                Me.WindowState = FormWindowState.Normal

                Me.tmrCheckStopFile.Enabled = False
                Me.tmrKillSelf.Enabled = False
                Me.tmrJustStarted.Enabled = False
                Me.ShowInTaskbar = True

                Me.txtHelp.Select(0, 0)

                Return
            End If

        Next

        'Dim ActualVolumeOld As Long
        'ActualVolumeOld = CLng(DesiredVolume * &HFFFF / 100)
        'ActualVolumeOld = (ActualVolumeOld * &HFFFF) + ActualVolume

        ActualVolume = CLng(DesiredVolume * &HFFFF / 100)
        ActualVolume = (ActualVolume And &HFFFF) Or (ActualVolume << 16)

        'MsgBox(ActualVolume.ToString("X16") + " " + ActualVolumeOld.ToString("X16"))


        '@@ Theoretically?  Documentation for waveOutSetVolume says this may or may not be supported by the actual output device
        If (UsingVolumeLeft) Then
            ActualVolumeLeft = CLng(DesiredVolumeLeft * &HFFFF / 100)
            ActualVolume = (ActualVolume And &HFFFF0000) Or (ActualVolumeLeft)
        End If

        If (UsingVolumeRight) Then
            ActualVolumeRight = CLng(DesiredVolumeRight * &HFFFF / 100)
            ActualVolume = (ActualVolume And &HFFFF) Or (ActualVolumeRight << 16)
        End If

        'override everything if usingvolumehex is in play
        If (UsingVolumeHex) Then
            ActualVolume = (ActualVolume And &H0) Or DesiredVolumeHex
        End If

        If ModeStop Then
            Dim file As System.IO.FileStream
            file = System.IO.File.Create("stopfile")
            file.Close()
        End If

        If StopSame = True Then
            Dim file2 As System.IO.FileStream
            file2 = System.IO.File.Create(IndividualStopfile)
            file2.Close()
        End If

        If StartUnique = True Then
            If Dir(IndividualStartfile) <> "" Then
                TerminateSelf()
            End If

            Dim file3 As System.IO.FileStream
            file3 = System.IO.File.Create(IndividualStartfile)
            file3.Close()
        End If


        If ModeAsync = True Or ModeTimer = True Then
            tmrKillSelf.Interval = ModeTimerValue
            tmrKillSelf.Enabled = True
        End If


        If wavFilePath = "" Then
            End
        End If

        If ModeAsync = True Then
            ' async, we kick it off and go
            sndPlaySound(System.IO.Path.GetFullPath(wavFilePath), Flags)
        Else

            trd = New Threading.Thread(AddressOf PlayWav)
            trd.IsBackground = True
            trd.Start()

        End If

    End Sub

    Private Sub tmrCheckStopFile_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrCheckStopFile.Tick

        If tmrJustStarted.Enabled = False Then
            If Dir("stopfile") <> "" Then
                TerminateSelf()
                End

            End If

            If Dir(IndividualStopfile) <> "" Then
                TerminateSelf()
                End
            End If
        End If

        tmrCheckStopFile.Enabled = True
    End Sub

    Private Sub tmrJustStarted_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrJustStarted.Tick
        ' if you tell me stop stop before 150 ms have passed, I am going to ignore it.
        ' (150 must be bigger than the interval that the competing process is checking for it.  If I see a stopfile at 150, then
        '  I am assuming it is one that I made... and stopping self isn't desired)
        If Dir("stopfile") <> "" Then
            Kill("stopfile")
        End If

        If Dir(IndividualStopfile) <> "" Then
            Kill(IndividualStopfile)
        End If

        tmrJustStarted.Enabled = False
    End Sub

    Private Sub TerminateSelf()
        ' I know now why you cry, but it is something I can never do.
        Dim pid As Integer
        pid = System.Diagnostics.Process.GetCurrentProcess().Id

        System.Diagnostics.Process.GetProcessById(pid).Kill()


    End Sub

    Private Sub tmrKillSelf_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrKillSelf.Tick

        ' ending naturally, drop the startfile
        If Dir(IndividualStartfile) <> "" Then
            Kill(IndividualStartfile)
        End If

        ' being as we are ending naturally, we should be nice and clean up the other junk
        If Dir("stopfile") <> "" Then
            Kill("stopfile")
        End If

        If Dir(IndividualStopfile) <> "" Then
            Kill(IndividualStopfile)
        End If

        TerminateSelf()
    End Sub


End Class




